OpenShot Audio Library | OpenShotAudio: juce::OutputStream Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::OutputStream Class Referenceabstract

`#include <juce_OutputStream.h>`

Inheritance diagram for juce::OutputStream:

## Public Member Functions
virtual | ~OutputStream ()
virtual void | flush ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual int64 | getPosition ()=0
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
virtual bool | writeByte (char byte)
virtual bool | writeBool (bool boolValue)
virtual bool | writeShort (short value)
virtual bool | writeShortBigEndian (short value)
virtual bool | writeInt (int value)
virtual bool | writeIntBigEndian (int value)
virtual bool | writeInt64 (int64 value)
virtual bool | writeInt64BigEndian (int64 value)
virtual bool | writeFloat (float value)
virtual bool | writeFloatBigEndian (float value)
virtual bool | writeDouble (double value)
virtual bool | writeDoubleBigEndian (double value)
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
virtual bool | writeCompressedInt (int value)
virtual bool | writeString (const String &text)
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
void | setNewLineString (const String &newLineString)
const String & | getNewLineString () const noexcept

## Detailed Description

The base class for streams that write data to some kind of destination.

Input and output streams are used throughout the library - subclasses can override some or all of the virtual functions to implement their behaviour.

See also
  InputStream, MemoryOutputStream, FileOutputStream

Definition at line 37 of file juce_OutputStream.h.

## Constructor & Destructor Documentation

## ◆ OutputStream()

juce::OutputStream::OutputStream | ( |  | ) |
| protected

Definition at line 59 of file juce_OutputStream.cpp.

## ◆ ~OutputStream()

juce::OutputStream::~OutputStream | ( |  | ) |
| virtual

Destructor.

Some subclasses might want to do things like call flush() during their destructors.

Definition at line 68 of file juce_OutputStream.cpp.

Referenced by ~OutputStream().

## Member Function Documentation

## ◆ flush()

virtual void juce::OutputStream::flush | ( |  | ) |
| pure virtual

If the stream is using a buffer, this will ensure it gets written out to the destination.

Implemented in juce::FileOutputStream, juce::GZIPCompressorOutputStream, and juce::MemoryOutputStream.

Referenced by juce::MidiFile::writeTo().

## ◆ getNewLineString()

const String & juce::OutputStream::getNewLineString | ( |  | ) | const
| inlinenoexcept

Returns the current new-line string that was set by setNewLineString().

Definition at line 231 of file juce_OutputStream.h.

## ◆ getPosition()

virtual int64 juce::OutputStream::getPosition | ( |  | ) |
| pure virtual

Returns the stream's current position.

See also
  setPosition

Implemented in juce::FileOutputStream, juce::GZIPCompressorOutputStream, and juce::MemoryOutputStream.

Referenced by juce::ZipFile::Builder::writeToStream().

## ◆ setNewLineString()

void juce::OutputStream::setNewLineString | ( | const String & | newLineString | ) |

Sets the string to write to the stream when a new line is written. By default this will be set the value of NewLine::getDefault().

Definition at line 321 of file juce_OutputStream.cpp.

Referenced by setNewLineString(), and write().

## ◆ setPosition()

virtual bool juce::OutputStream::setPosition | ( | int64 | newPosition | ) |
| pure virtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implemented in juce::FileOutputStream, juce::GZIPCompressorOutputStream, and juce::MemoryOutputStream.

## ◆ write()

virtual bool juce::OutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes )
| pure virtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implemented in juce::FileOutputStream, juce::GZIPCompressorOutputStream, and juce::MemoryOutputStream.

Referenced by juce::Base64::convertToBase64(), writeByte(), writeCompressedInt(), writeFromInputStream(), writeInt(), writeInt64(), writeInt64BigEndian(), writeIntBigEndian(), writeShort(), writeShortBigEndian(), writeString(), and writeText().

## ◆ writeBool()

bool juce::OutputStream::writeBool | ( | bool | boolValue | ) |
| virtual

Writes a boolean to the stream as a single byte. This is encoded as a binary byte (not as text) with a value of 1 or 0.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readBool

Definition at line 77 of file juce_OutputStream.cpp.

Referenced by write(), and writeBool().

## ◆ writeByte()

bool juce::OutputStream::writeByte | ( | char | byte | ) |
| virtual

Writes a single byte to the stream.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readByte

Definition at line 83 of file juce_OutputStream.cpp.

Referenced by juce::Base64::convertFromBase64(), juce::XmlDocument::getDocumentElement(), juce::InputStream::readNextLine(), juce::InputStream::readString(), write(), writeBool(), writeByte(), writeRepeatedByte(), writeText(), and juce::XmlElement::writeTo().

## ◆ writeCompressedInt()

bool juce::OutputStream::writeCompressedInt | ( | int | value | ) |
| virtual

Writes a condensed binary encoding of a 32-bit integer.

If you're storing a lot of integers which are unlikely to have very large values, this can save a lot of space, because values under 0xff will only take up 2 bytes, under 0xffff only 3 bytes, etc.

The format used is: number of significant bytes + up to 4 bytes in little-endian order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readCompressedInt

Definition at line 121 of file juce_OutputStream.cpp.

Referenced by write(), and writeCompressedInt().

## ◆ writeDouble()

bool juce::OutputStream::writeDouble | ( | double | value | ) |
| virtual

Writes a 64-bit floating point value to the stream in a binary format. The eight raw bytes of the double value are written out as a little-endian 64-bit int.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readDouble

Definition at line 169 of file juce_OutputStream.cpp.

Referenced by write(), and writeDouble().

## ◆ writeDoubleBigEndian()

bool juce::OutputStream::writeDoubleBigEndian | ( | double | value | ) |
| virtual

Writes a 64-bit floating point value to the stream in a binary format. The eight raw bytes of the double value are written out as a big-endian 64-bit int.

See also
  InputStream::readDoubleBigEndian

Returns
  false if the write operation fails for some reason

Definition at line 176 of file juce_OutputStream.cpp.

Referenced by write(), and writeDoubleBigEndian().

## ◆ writeFloat()

bool juce::OutputStream::writeFloat | ( | float | value | ) |
| virtual

Writes a 32-bit floating point value to the stream in a binary format. The binary 32-bit encoding of the float is written as a little-endian int.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readFloat

Definition at line 155 of file juce_OutputStream.cpp.

Referenced by write(), and writeFloat().

## ◆ writeFloatBigEndian()

bool juce::OutputStream::writeFloatBigEndian | ( | float | value | ) |
| virtual

Writes a 32-bit floating point value to the stream in a binary format. The binary 32-bit encoding of the float is written as a big-endian int.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readFloatBigEndian

Definition at line 162 of file juce_OutputStream.cpp.

Referenced by write(), and writeFloatBigEndian().

## ◆ writeFromInputStream()

int64 juce::OutputStream::writeFromInputStream | ( | InputStream & | source,
|  | int64 | maxNumBytesToWrite )
| virtual

Reads data from an input stream and writes it to this stream.

Parameters

  source | the stream to read from
  maxNumBytesToWrite | the number of bytes to read from the stream (if this is less than zero, it will keep reading until the input is exhausted)

Returns
  the number of bytes written

Reimplemented in juce::MemoryOutputStream.

Definition at line 296 of file juce_OutputStream.cpp.

Referenced by juce::FileLogger::trimFileSize(), write(), juce::MemoryOutputStream::writeFromInputStream(), and writeFromInputStream().

## ◆ writeInt()

bool juce::OutputStream::writeInt | ( | int | value | ) |
| virtual

Writes a 32-bit integer to the stream in a little-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readInt

Definition at line 109 of file juce_OutputStream.cpp.

Referenced by write(), writeFloat(), writeInt(), and juce::ZipFile::Builder::writeToStream().

## ◆ writeInt64()

bool juce::OutputStream::writeInt64 | ( | int64 | value | ) |
| virtual

Writes a 64-bit integer to the stream in a little-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readInt64

Definition at line 143 of file juce_OutputStream.cpp.

Referenced by write(), writeDouble(), and writeInt64().

## ◆ writeInt64BigEndian()

bool juce::OutputStream::writeInt64BigEndian | ( | int64 | value | ) |
| virtual

Writes a 64-bit integer to the stream in a big-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readInt64BigEndian

Definition at line 149 of file juce_OutputStream.cpp.

Referenced by write(), writeDoubleBigEndian(), and writeInt64BigEndian().

## ◆ writeIntBigEndian()

bool juce::OutputStream::writeIntBigEndian | ( | int | value | ) |
| virtual

Writes a 32-bit integer to the stream in a big-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readIntBigEndian

Definition at line 115 of file juce_OutputStream.cpp.

Referenced by write(), writeFloatBigEndian(), writeIntBigEndian(), and juce::MidiFile::writeTo().

## ◆ writeRepeatedByte()

bool juce::OutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat )
| virtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented in juce::FileOutputStream, and juce::MemoryOutputStream.

Definition at line 88 of file juce_OutputStream.cpp.

Referenced by write(), juce::FileOutputStream::writeRepeatedByte(), and writeRepeatedByte().

## ◆ writeShort()

bool juce::OutputStream::writeShort | ( | short | value | ) |
| virtual

Writes a 16-bit integer to the stream in a little-endian byte order. This will write two bytes to the stream: (value & 0xff), then (value >> 8).

Returns
  false if the write operation fails for some reason

See also
  InputStream::readShort

Definition at line 97 of file juce_OutputStream.cpp.

Referenced by write(), writeShort(), writeText(), and juce::ZipFile::Builder::writeToStream().

## ◆ writeShortBigEndian()

bool juce::OutputStream::writeShortBigEndian | ( | short | value | ) |
| virtual

Writes a 16-bit integer to the stream in a big-endian byte order. This will write two bytes to the stream: (value >> 8), then (value & 0xff).

Returns
  false if the write operation fails for some reason

See also
  InputStream::readShortBigEndian

Definition at line 103 of file juce_OutputStream.cpp.

Referenced by write(), writeShortBigEndian(), and juce::MidiFile::writeTo().

## ◆ writeString()

bool juce::OutputStream::writeString | ( | const String & | text | ) |
| virtual

Stores a string in the stream in a binary format.

This isn't the method to use if you're trying to append text to the end of a text-file! It's intended for storing a string so that it can be retrieved later by InputStream::readString().

It writes the string to the stream as UTF8, including the null termination character.

For appending text to a file, instead use writeText, or operator<<

Returns
  false if the write operation fails for some reason

See also
  InputStream::readString, writeText, operator<<

Definition at line 183 of file juce_OutputStream.cpp.

Referenced by write(), and writeString().

## ◆ writeText()

bool juce::OutputStream::writeText | ( | const String & | text,
|  | bool | asUTF16,
|  | bool | writeUTF16ByteOrderMark,
|  | const char * | lineEndings )
| virtual

Writes a string of text to the stream.

It can either write the text as UTF-8 or UTF-16, and can also add the UTF-16 byte-order-mark bytes (0xff, 0xfe) to indicate the endianness (these should only be used at the start of a file).

If lineEndings is nullptr, then line endings in the text won't be modified. If you pass "\\n" or "\\r\\n" then this function will replace any existing line feeds.

Returns
  false if the write operation fails for some reason

Definition at line 198 of file juce_OutputStream.cpp.

Referenced by juce::File::appendText(), write(), and writeText().

The documentation for this class was generated from the following files:

- juce_OutputStream.h
- juce_OutputStream.cpp